/**
 * generated by Xtext 2.35.0
 */
package org.tfranke.webservice.dsl.generator;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.common.collect.Iterables;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import webservice.API;
import webservice.BooleanData;
import webservice.CollectionDataType;
import webservice.CreateOperation;
import webservice.DataType;
import webservice.DeleteOperation;
import webservice.FloatData;
import webservice.IntegerData;
import webservice.ObjectDataType;
import webservice.Operation;
import webservice.Parameter;
import webservice.ReadOperation;
import webservice.StringData;
import webservice.UpdateOperation;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class WebserviceDSLGenerator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource res, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Iterable<API> _filter = Iterables.<API>filter(IteratorExtensions.<EObject>toIterable(res.getAllContents()), API.class);
    for (final API api : _filter) {
      {
        String _name = api.getName();
        String _plus = ("openAPI/" + _name);
        String _plus_1 = (_plus + ".json");
        fsa.generateFile(_plus_1, this.formatJson(this.generateOpenApi(api)));
        TransconnectRepositoryCreator.createRepository(api, fsa);
      }
    }
  }

  /**
   * This methods creates an openApi specification in Json form from an API Object.
   */
  public String generateOpenApi(final API api) {
    String _xblockexpression = null;
    {
      final List<DataType> complexTypes = new ArrayList<DataType>();
      EList<DataType> _datatypes = api.getDatatypes();
      for (final DataType datatype : _datatypes) {
        if (((datatype instanceof ObjectDataType) || (datatype instanceof CollectionDataType))) {
          complexTypes.add(datatype);
        }
      }
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("{");
      _builder.newLine();
      _builder.append("  ");
      _builder.append("\"openapi\": \"3.0.0\",");
      _builder.newLine();
      _builder.append("  ");
      _builder.append("\"info\": {");
      _builder.newLine();
      _builder.append("  \t");
      _builder.append("\"title\": \"");
      String _name = api.getName();
      _builder.append(_name, "  \t");
      _builder.append("\",");
      _builder.newLineIfNotEmpty();
      _builder.append("  \t");
      _builder.append("\"description\": \"");
      String _description = api.getDescription();
      _builder.append(_description, "  \t");
      _builder.append("\",");
      _builder.newLineIfNotEmpty();
      _builder.append("    ");
      _builder.append("\"version\": \"1.0.0\"");
      _builder.newLine();
      _builder.append("  ");
      _builder.append("},");
      _builder.newLine();
      _builder.append("  ");
      _builder.append("\"servers\": [");
      _builder.newLine();
      _builder.append("    ");
      _builder.append("{");
      _builder.newLine();
      _builder.append("      ");
      _builder.append("\"url\": \"");
      String _url = api.getUrl();
      _builder.append(_url, "      ");
      _builder.append("\",");
      _builder.newLineIfNotEmpty();
      _builder.append("      ");
      _builder.append("\"description\": \"");
      String _description_1 = api.getDescription();
      _builder.append(_description_1, "      ");
      _builder.append("\"");
      _builder.newLineIfNotEmpty();
      _builder.append("    ");
      _builder.append("}");
      _builder.newLine();
      _builder.append("  ");
      _builder.append("],");
      _builder.newLine();
      _builder.append("  ");
      _builder.append("\"paths\": {");
      _builder.newLine();
      _builder.append("    ");
      CharSequence _createEndpoints = this.createEndpoints(api);
      _builder.append(_createEndpoints, "    ");
      _builder.newLineIfNotEmpty();
      _builder.append("  ");
      _builder.append("}");
      {
        boolean _isEmpty = complexTypes.isEmpty();
        boolean _not = (!_isEmpty);
        if (_not) {
          _builder.append(",");
          _builder.newLineIfNotEmpty();
          _builder.append("\t");
          _builder.append("\"components\" : {");
          _builder.newLine();
          _builder.append("\t\t");
          _builder.append("\"schemas\": {");
          _builder.newLine();
          {
            boolean _hasElements = false;
            for(final DataType datatype_1 : complexTypes) {
              if (!_hasElements) {
                _hasElements = true;
              } else {
                _builder.appendImmediate(",", "\t\t\t");
              }
              {
                if ((datatype_1 instanceof ObjectDataType)) {
                  _builder.append("\t\t\t");
                  String _constructObjectDataTypeSchema = this.constructObjectDataTypeSchema(((ObjectDataType)datatype_1));
                  _builder.append(_constructObjectDataTypeSchema, "\t\t\t");
                  _builder.newLineIfNotEmpty();
                } else {
                  if ((datatype_1 instanceof CollectionDataType)) {
                    _builder.append("\t\t\t");
                    CharSequence _constructArrayDataTypeSchema = this.constructArrayDataTypeSchema(((CollectionDataType)datatype_1));
                    _builder.append(_constructArrayDataTypeSchema, "\t\t\t");
                    _builder.newLineIfNotEmpty();
                  }
                }
              }
            }
          }
          _builder.append("\t\t\t");
          _builder.append("}");
          _builder.newLine();
          _builder.append("\t\t");
          _builder.append("}");
          _builder.newLine();
        }
      }
      _builder.append("}\t\t");
      _builder.newLine();
      _xblockexpression = _builder.toString();
    }
    return _xblockexpression;
  }

  /**
   * This method creates the openApi Json representation of a schema of an object datatype.
   */
  public String constructObjectDataTypeSchema(final ObjectDataType object) {
    String _xblockexpression = null;
    {
      final EList<DataType> properties = object.getDatatypes();
      final List<DataType> requiredProperties = new ArrayList<DataType>();
      for (final DataType property : properties) {
        boolean _isRequired = property.isRequired();
        if (_isRequired) {
          requiredProperties.add(property);
        }
      }
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("\"");
      String _name = object.getName();
      _builder.append(_name);
      _builder.append("\": {");
      _builder.newLineIfNotEmpty();
      _builder.append("\t        ");
      _builder.append("\"type\": \"object\",");
      _builder.newLine();
      _builder.append("\t        ");
      _builder.append("\"properties\": {");
      _builder.newLine();
      {
        boolean _hasElements = false;
        for(final DataType property_1 : properties) {
          if (!_hasElements) {
            _hasElements = true;
          } else {
            _builder.appendImmediate(",", "\t          ");
          }
          _builder.append("\t          ");
          _builder.append("\"");
          String _name_1 = property_1.getName();
          _builder.append(_name_1, "\t          ");
          _builder.append("\": {");
          _builder.newLineIfNotEmpty();
          _builder.append("\t          ");
          _builder.append(" \t");
          String _typeOfData = this.getTypeOfData(property_1);
          _builder.append(_typeOfData, "\t           \t");
          _builder.newLineIfNotEmpty();
          _builder.append("\t          ");
          _builder.append("}");
          _builder.newLine();
        }
      }
      _builder.append("\t        ");
      _builder.append("}");
      {
        boolean _isEmpty = requiredProperties.isEmpty();
        boolean _not = (!_isEmpty);
        if (_not) {
          _builder.append(",");
          _builder.newLineIfNotEmpty();
          _builder.append("\t        ");
          _builder.append("\"required\": [");
          _builder.newLine();
          {
            boolean _hasElements_1 = false;
            for(final DataType property_2 : requiredProperties) {
              if (!_hasElements_1) {
                _hasElements_1 = true;
              } else {
                _builder.appendImmediate(",", "\t        ");
              }
              _builder.append("\t        ");
              _builder.append("\"");
              String _name_2 = property_2.getName();
              _builder.append(_name_2, "\t        ");
              _builder.append("\"");
              _builder.newLineIfNotEmpty();
            }
          }
          _builder.append("\t        ");
          _builder.append("]");
          _builder.newLine();
        }
      }
      _builder.append("        ");
      _builder.append("}");
      _builder.newLine();
      _xblockexpression = _builder.toString();
    }
    return _xblockexpression;
  }

  /**
   * This method creates the openApi Json representation of a schema of an array datatype.
   */
  public CharSequence constructArrayDataTypeSchema(final CollectionDataType datatype) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("\"");
    String _name = datatype.getName();
    _builder.append(_name);
    _builder.append("\": {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t        ");
    _builder.append("\"type\": \"array\",");
    _builder.newLine();
    _builder.append("\t        ");
    _builder.append("\"items\": {");
    _builder.newLine();
    _builder.append("\t          ");
    String _typeOfData = this.getTypeOfData(datatype.getListItem());
    _builder.append(_typeOfData, "\t          ");
    _builder.newLineIfNotEmpty();
    _builder.append("\t        ");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t      ");
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }

  /**
   * This method creates the openApi Json representation of an endpoint.
   */
  public CharSequence createEndpoints(final API api) {
    CharSequence _xblockexpression = null;
    {
      final Map<String, List<Operation>> urlToOperation = this.mapUrlToOperations(api);
      StringConcatenation _builder = new StringConcatenation();
      {
        Set<String> _keySet = urlToOperation.keySet();
        boolean _hasElements = false;
        for(final String url : _keySet) {
          if (!_hasElements) {
            _hasElements = true;
          } else {
            _builder.appendImmediate(",", "");
          }
          _builder.append("\"");
          _builder.append(url);
          _builder.append("\": {");
          _builder.newLineIfNotEmpty();
          {
            List<Operation> _get = urlToOperation.get(url);
            boolean _hasElements_1 = false;
            for(final Operation operation : _get) {
              if (!_hasElements_1) {
                _hasElements_1 = true;
              } else {
                _builder.appendImmediate(",", "  ");
              }
              _builder.append("  ");
              _builder.append("\"");
              String _httpMethodFromOperation = this.getHttpMethodFromOperation(operation);
              _builder.append(_httpMethodFromOperation, "  ");
              _builder.append("\": {");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("  ");
              _builder.append("\"summary\": \"");
              String _description = operation.getDescription();
              _builder.append(_description, "    ");
              _builder.append("\",");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("  ");
              _builder.append("\"operationId\": \"");
              String _name = operation.getName();
              _builder.append(_name, "    ");
              _builder.append("\",");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("  ");
              String _handleOperationParameters = this.handleOperationParameters(operation, url);
              _builder.append(_handleOperationParameters, "    ");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("  ");
              {
                DataType _response = operation.getResponse();
                boolean _tripleNotEquals = (_response != null);
                if (_tripleNotEquals) {
                  _builder.append(",");
                  _builder.newLineIfNotEmpty();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("\"responses\": {");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("\"200\": {");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("  \t");
                  _builder.append("\"description\": \"OK\",");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("    ");
                  _builder.append("\"content\": {");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("      ");
                  _builder.append("\"*/*\": {");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("        ");
                  _builder.append("\"schema\": {");
                  _builder.newLine();
                  _builder.append("\t        \t      ");
                  String _typeOfData = this.getTypeOfData(operation.getResponse());
                  _builder.append(_typeOfData, "\t        \t      ");
                  _builder.newLineIfNotEmpty();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("        ");
                  _builder.append("}");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("      ");
                  _builder.append("}");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("    ");
                  _builder.append("}");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("}");
                  _builder.newLine();
                  _builder.append("  ");
                  _builder.append("  ");
                  _builder.append("}");
                  _builder.newLine();
                }
              }
              _builder.append("  ");
              _builder.append("}");
              _builder.newLine();
            }
          }
          _builder.append("}");
          _builder.newLine();
        }
      }
      _xblockexpression = _builder;
    }
    return _xblockexpression;
  }

  /**
   * Handles all request parameters for the given operation. Evaluates if: parameters belong to url path,
   * if they are query parameters, or if they belong to the "requestBody". If there are multiple "requestBody" parameters they
   * will be included in a "anyOf" tag.
   */
  public String handleOperationParameters(final Operation operation, final String url) {
    String _xblockexpression = null;
    {
      final List<Parameter> requestBodyData = new ArrayList<Parameter>();
      final List<Parameter> parameterData = new ArrayList<Parameter>();
      if (((operation instanceof ReadOperation) || (operation instanceof DeleteOperation))) {
        parameterData.addAll(operation.getParameters());
      } else {
        EList<Parameter> _parameters = operation.getParameters();
        for (final Parameter parameter : _parameters) {
          {
            final DataType datatype = parameter.getDatatype();
            if (((datatype instanceof ObjectDataType) || (datatype instanceof CollectionDataType))) {
              requestBodyData.add(parameter);
            } else {
              parameterData.add(parameter);
            }
          }
        }
      }
      StringConcatenation _builder = new StringConcatenation();
      {
        boolean _isEmpty = requestBodyData.isEmpty();
        boolean _not = (!_isEmpty);
        if (_not) {
          _builder.append("\"requestBody\": {");
          _builder.newLine();
          _builder.append("          ");
          _builder.append("\"content\": {");
          _builder.newLine();
          _builder.append("            ");
          _builder.append("\"*/*\": {");
          _builder.newLine();
          _builder.append("              ");
          _builder.append("\"schema\": {");
          _builder.newLine();
          {
            int _size = requestBodyData.size();
            boolean _greaterThan = (_size > 1);
            if (_greaterThan) {
              _builder.append("              \t");
              _builder.append("\"anyOf\": [");
              _builder.newLine();
              {
                boolean _hasElements = false;
                for(final Parameter parameter_1 : requestBodyData) {
                  if (!_hasElements) {
                    _hasElements = true;
                  } else {
                    _builder.appendImmediate(",", "");
                  }
                  _builder.append("{");
                  String _typeOfData = this.getTypeOfData(parameter_1.getDatatype());
                  _builder.append(_typeOfData);
                  _builder.append("}");
                  _builder.newLineIfNotEmpty();
                }
              }
              _builder.append("\t\t                ");
              _builder.append("]");
              _builder.newLine();
            } else {
              String _typeOfData_1 = this.getTypeOfData(requestBodyData.get(0).getDatatype());
              _builder.append(_typeOfData_1);
              _builder.newLineIfNotEmpty();
            }
          }
          _builder.append("              ");
          _builder.append("}");
          _builder.newLine();
          _builder.append("            ");
          _builder.append("}");
          _builder.newLine();
          _builder.append("          ");
          _builder.append("}");
          _builder.newLine();
          _builder.append("        ");
          _builder.append("}");
          _builder.newLine();
        }
      }
      {
        boolean _isEmpty_1 = parameterData.isEmpty();
        boolean _not_1 = (!_isEmpty_1);
        if (_not_1) {
          {
            boolean _isEmpty_2 = requestBodyData.isEmpty();
            boolean _not_2 = (!_isEmpty_2);
            if (_not_2) {
              _builder.append(",");
            }
          }
          _builder.newLineIfNotEmpty();
          _builder.append("\"parameters\": [");
          _builder.newLine();
          {
            boolean _hasElements_1 = false;
            for(final Parameter parameter_2 : parameterData) {
              if (!_hasElements_1) {
                _hasElements_1 = true;
              } else {
                _builder.appendImmediate(",", "");
              }
              _builder.append("  ");
              _builder.append("{");
              _builder.newLine();
              _builder.append("  ");
              _builder.append("\"name\": \"");
              String _name = parameter_2.getDatatype().getName();
              _builder.append(_name, "  ");
              _builder.append("\",");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("\"in\": \"");
              String _parameterType = this.getParameterType(parameter_2, url);
              _builder.append(_parameterType, "  ");
              _builder.append("\",");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("\"description\": \"");
              String _description = parameter_2.getDescription();
              _builder.append(_description, "  ");
              _builder.append("\",");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("\"required\": ");
              boolean _isRequired = parameter_2.isRequired();
              _builder.append(_isRequired, "  ");
              _builder.append(",");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("\"schema\": {");
              _builder.newLine();
              _builder.append("  \t");
              String _typeOfData_2 = this.getTypeOfData(parameter_2.getDatatype());
              _builder.append(_typeOfData_2, "  \t");
              _builder.newLineIfNotEmpty();
              _builder.append("  ");
              _builder.append("}");
              _builder.newLine();
              _builder.append("}");
              _builder.newLine();
            }
          }
          _builder.append("\t    ");
          _builder.append("]");
          _builder.newLine();
        }
      }
      _xblockexpression = _builder.toString();
    }
    return _xblockexpression;
  }

  /**
   * This method returns a map that contains all urls as keys and a list of Operations belonging to that url.
   */
  public Map<String, List<Operation>> mapUrlToOperations(final API api) {
    final Map<String, List<Operation>> urlToOperationsMap = new HashMap<String, List<Operation>>();
    EList<Operation> _operations = api.getOperations();
    for (final Operation operation : _operations) {
      {
        final String url = operation.getUrlSuffix();
        boolean _containsKey = urlToOperationsMap.containsKey(url);
        if (_containsKey) {
          urlToOperationsMap.get(url).add(operation);
        } else {
          urlToOperationsMap.put(url, CollectionLiterals.<Operation>newArrayList(operation));
        }
      }
    }
    return urlToOperationsMap;
  }

  /**
   * This method evaluates whether the given parameter is a path or query parameter.
   */
  public String getParameterType(final Parameter parameter, final String url) {
    final List<String> urlParameter = new ArrayList<String>();
    final Pattern pattern = Pattern.compile("\\{([^}]*)\\}");
    final Matcher matcher = pattern.matcher(url);
    while (matcher.find()) {
      urlParameter.add(matcher.group(1).toLowerCase());
    }
    boolean _contains = urlParameter.contains(parameter.getDatatype().getName().toLowerCase());
    if (_contains) {
      return "path";
    }
    return "query";
  }

  /**
   * This method returns the associated HTTP-Method for an Operation object.
   */
  public String getHttpMethodFromOperation(final Operation operation) {
    if ((operation instanceof ReadOperation)) {
      return "get";
    }
    if ((operation instanceof CreateOperation)) {
      return "post";
    }
    if ((operation instanceof UpdateOperation)) {
      return "put";
    }
    if ((operation instanceof DeleteOperation)) {
      return "delete";
    }
    return "other";
  }

  /**
   * This methods returns the openApi json representation of different types of data.
   */
  public String getTypeOfData(final DataType datatype) {
    if ((datatype instanceof StringData)) {
      return "\"type\": \"string\"";
    }
    if ((datatype instanceof IntegerData)) {
      return "\"type\": \"integer\"";
    }
    if ((datatype instanceof BooleanData)) {
      return "\"type\": \"boolean\"";
    }
    if ((datatype instanceof FloatData)) {
      return "\"type\": \"float\"";
    }
    if (((datatype instanceof ObjectDataType) || (datatype instanceof CollectionDataType))) {
      String _name = datatype.getName();
      String _plus = ("\"$ref\" : \"#/components/schemas/" + _name);
      return (_plus + "\"");
    }
    return null;
  }

  /**
   * This methods formats the given Json string.
   */
  public String formatJson(final String unformattedString) {
    try {
      final ObjectMapper objectMapper = new ObjectMapper();
      final Object jsonObject = objectMapper.<Object>readValue(unformattedString, Object.class);
      final String prettyJson = objectMapper.writerWithDefaultPrettyPrinter().writeValueAsString(jsonObject);
      return prettyJson;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
